//for version 2.53
library LedNumberEx;

uses Windows,drawShare,kol;

procedure Draw(PRec:PParamRec; ed:pointer; dc:HDC); cdecl;
var
  str: string;
  i, nx, bfD, afD: integer;
  FWidth: integer;
  FHeight: integer;
  
  ArElRgn: array [0..6] of HRGN;
  p: array [0..5] of TPoint;
  r: TRect;
  Size: DWORD;
  tmRgn: HRGN;
  wXFORM: XFORM;
  RgnData: PRgnData;
  zr, rd: integer;
  FShadow        :Integer;//FNoSegColor
  FForeground    :Integer;//FSegColor
  FBackground    :Integer;//fFonColor
  FDrawBuffer    :PBitmap;   
  FPadding       :Integer;//    
  FSpace         :Integer;//   
  FDigWidth      :Integer;//  ( )   FItalicWidth (   FDigWidth + FItalicWidth)
  FDigSize       :Integer;//  ( )
  FItalicWidth   :Integer;//  (   FDigWidth + FItalicWidth) 
  FTextWidth     :Integer;//    ( )
  FDotSize       :Integer;//       ()
  FColorHover    :Boolean;//     
  FRound         :Boolean;//  
  FItalic        :Boolean;// 
  FAutoWidth     :Boolean;//    FTextWidth
  FShowLines     :Boolean;//      FNoSegColor
  FOutLine       :Boolean;//    FSegColor
  FWidthOutLine  :Integer;//      FSegColor
  FSegmentColon  :Boolean;//   ,  False  
  FTextBits      :Boolean;//       (FDelimiter)
  FAddDot        :Boolean;// FTextBits = true     
  FText          :String;// 
  FDelimiter     :String;// ()   FText  FTextBits = True
  STextAlign     :byte;//  (, ,  )


  function StrScan(Str: PChar; Chr: Char): PChar; assembler;
  asm
      PUSH    EDI
      PUSH    EAX
      MOV     EDI,Str
      OR      ECX, -1
      XOR     AL,AL
      REPNE   SCASB
      NOT     ECX
      POP     EDI
      XCHG    EAX, EDX
      REPNE   SCASB
      XCHG    EAX, EDI
      POP     EDI
      JE      @@1
      MOV     EAX,1
  @@1:    DEC     EAX
  end {$IFDEF F_P} [ 'EAX', 'EDX', 'ECX' ] {$ENDIF};

  function FParse(var S: string; const Delimiters: char): string;
  var
    Pos: Integer;
    P, F: PChar;
  begin
    P := PChar(S);
    F := StrScan(P, Delimiters);
    if F <> nil then
      Pos := Integer(F) - Integer(P) + 1
    else
      Pos := Length(S) + 1;    
    Result := S;
    S := CopyEnd(Result, Pos + 1);
    Result := Copy(Result, 1, Pos - 1);
  end;

  function SetPoint(px, py: integer):TPoint;
  begin
    Result.X := px;
    Result.Y := py;
  end;
  
  // 
  procedure DrawSymbol(ch: Char; Color: TColor);
  var w, h, iw: integer;
    FRegion, tmpRgn: HRGN;
    br: HBrush;
  begin
   with PCanvas(FDrawBuffer.Canvas){$ifndef F_P}^{$endif} do
    begin
     Pen.Color := Color; 
     if FOutline  
      then Brush.Color := FBackground
      else Brush.Color := Color;
     case ch of
     '.': begin
           w := nx + bfD;
           h := FDrawBuffer.Height - FPadding;
           if FRound then
             FRegion := CreateEllipticRgn(w, h - FDigSize, w + FDigSize, h)
           else
	     FRegion := CreateRectRgn(w, h - FDigSize, w + FDigSize, h);
          end;
     ':': begin
           w := nx + bfD;
           h := FDrawBuffer.Height div 2;
           iw := FItalicWidth div 3;
           if FRound then
            begin
             FRegion := CreateEllipticRgn(w, h - FDigSize * 2, w + FDigSize, h - FDigSize);
             tmpRgn := CreateEllipticRgn(w, h + FDigSize * 2, w + FDigSize, h + FDigSize);
             CombineRgn(FRegion, FRegion, tmpRgn, RGN_OR);
             DeleteObject(tmpRgn);
            end
           else
            begin
             FRegion := CreateRectRgn(w + iw, h - FDigSize * 2, w + FDigSize + iw, h - FDigSize);
             tmpRgn := CreateRectRgn(w - iw, h + FDigSize * 2, w + FDigSize - iw, h + FDigSize);
             CombineRgn(FRegion, FRegion, tmpRgn, RGN_OR);
             DeleteObject(tmpRgn);
            end; 
          end;
      else
        FRegion := CreateRectRgn(0,0,0,0);
     end;
    if FOutline and (Color =  FForeground) then
      begin
        br := CreateSolidBrush(FForeground);
        FrameRgn(Handle, FRegion, br, FWidthOutLine, FWidthOutLine);
        DeleteObject(br);
      end
    else FillRgn(FRegion);
    end;
    DeleteObject(FRegion);
    inc(nx, bfD + fDigSize + afD + FSpace);//     +   +    +   
  end;

  //  
  procedure DrawSegment(Number: Integer; Color: TColor);
  var bt: integer;
      br: HBrush;
  begin
    with PCanvas(FDrawBuffer.Canvas){$ifndef F_P}^{$endif} do
     begin
      Pen.Color := Color;
      Brush.Color := Color;
      for bt := 0 to 7 do
       if ((Number shr bt) and 1) = 1 then
        begin 
         OffsetRgn(ArElRgn[bt], nx, 0);//  ()   
         if FOutline and (Color =  FForeground) then
          begin
           br := CreateSolidBrush(FForeground);
           FrameRgn(Handle, ArElRgn[bt], br, FWidthOutLine, FWidthOutLine);
           DeleteObject(br);
          end
         else FillRgn(ArElRgn[bt]); 
         OffsetRgn(ArElRgn[bt], -nx, 0);//    ()
        end;
      inc(nx, FDigWidth + FSpace);
      if Number > 127 then DrawSymbol('.', Color)//   127     
       else if (Color = FForeground) and FAddDot and FTextBits then inc(nx, bfD + fDigSize + afD + FSpace); 
      if Color = fShadow then
       begin
        if (Number > 127) or (FAddDot and FTextBits) then dec(nx, bfD + fDigSize + afD + FSpace);  
        dec(nx, FDigWidth + FSpace);
       end;
     end;
  end;

begin

   FWidth         := integer(SearchParam(PRec, 'width').Value^);
   FHeight        := integer(SearchParam(PRec, 'height').Value^);
   FBackground    := ColorRGB(integer(SearchParam(PRec, 'FonColor').Value^));
   FForeground    := ColorRGB(integer(SearchParam(PRec, 'SegColor').Value^));
   FShadow        := ColorRGB(integer(SearchParam(PRec, 'NoSegColor').Value^));
   
   STextAlign     := byte(SearchParam(PRec, 'Alignment').Value^);
   FText          := string(SearchParam(PRec, 'Text').Value^);
   FTextBits      := not boolean(SearchParam(PRec, 'TextBits').Value^);
   FDelimiter     := string(SearchParam(PRec, 'Delimiter').Value^);
   FAddDot        := not boolean(SearchParam(PRec, 'AddDot').Value^);
   FShowLines     := not boolean(SearchParam(PRec, 'ShowLines').Value^);
   FOutLine       := not boolean(SearchParam(PRec, 'OutLine').Value^);
   FWidthOutLine  := integer(SearchParam(PRec, 'WidthOutLine').Value^);
   FRound         := not boolean(SearchParam(PRec, 'Round').Value^);
   FPadding       := integer(SearchParam(PRec, 'Padding').Value^);
   FSpace         := integer(SearchParam(PRec, 'Space').Value^);
   FItalic        := not boolean(SearchParam(PRec, 'Italic').Value^);
   FAutoWidth     := not boolean(SearchParam(PRec, 'AutoWidth').Value^);
   FDotSize       := integer(SearchParam(PRec, 'DotSize').Value^);
   FSegmentColon  := not boolean(SearchParam(PRec, 'SegmentColon').Value^);

   FDrawBuffer :=  NewDIBBitmap(FWidth, FHeight, pf32bit);
   FDrawBuffer.Canvas.Brush.Color := FBackground;
   FDrawBuffer.Canvas.Pen.Color := FBackground;
   FDrawBuffer.Canvas.Rectangle(0, 0, FWidth, FHeight);

   nx := FHeight - FPadding * 2;// 
   FDigWidth := 6 * nx div 10;// 
   inc(FDigWidth, ord(odd(FDigWidth)));//  -  
   FDigSize := FDigWidth div 6;// 
   inc(FDigSize, ord(odd(FDigSize)));//  -  
   rd := FDigSize * 2;// 
   zr := max(1, FDigSize div 6);//   

////////////////////////////////////////////////////////////////////////////////
///////////////////////     /////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
   
   //   ArElRgn[0]
    if FRound then ArElRgn[0] := CreateRoundRectRgn(0, FPadding, FDigWidth, FHeight, rd, rd)
    else ArElRgn[0] := CreateRectRgn(0, FPadding, FDigWidth, FHeight);
    tmRgn := CreateRectRgn(0, FDigSize + FPadding, FDigWidth, FHeight);
    CombineRgn(ArElRgn[0], ArElRgn[0], tmRgn, RGN_DIFF);// 
    DeleteObject(tmRgn);
    p[0] := SetPoint(0, FPadding);
    p[1] := SetPoint(zr, FPadding);    
    p[2] := SetPoint(FDigSize + zr * 2, FPadding + FDigSize + zr);
    p[3] := SetPoint(0, p[2].y * 2);
    tmRgn := CreatePolygonRgn(p[0], 4, Winding);
    CombineRgn(ArElRgn[0], ArElRgn[0], tmRgn, RGN_DIFF);// 
    DeleteObject(tmRgn);    
    p[0] := SetPoint(FDigWidth, FPadding);
    p[1] := SetPoint(FDigWidth - zr, FPadding);
    p[2] := SetPoint(FDigWidth - FDigSize - zr * 2, p[2].y);
    p[3] := SetPoint(FDigWidth , FPadding +(FDigSize + zr) * 2);
    tmRgn := CreatePolygonRgn(p[0], 4, Winding);
    CombineRgn(ArElRgn[0], ArElRgn[0], tmRgn, RGN_DIFF);//  
    DeleteObject(tmRgn);
    //    ArElRgn[5]
    if FRound then ArElRgn[5] := CreateRoundRectRgn(0, FPadding, FDigWidth, FHeight, rd, rd)
    else ArElRgn[5] := CreateRectRgn(0, FPadding, FDigWidth, FHeight);
    tmRgn := CreateRectRgn(FDigSize, FPadding, FDigWidth, FHeight);
    CombineRgn(ArElRgn[5], ArElRgn[5], tmRgn, RGN_DIFF);
    DeleteObject(tmRgn);
    p[0] := SetPoint(0, FPadding);
    p[1] := SetPoint(0, FPadding + zr);
    p[2] := SetPoint(FDigSize + zr, FPadding + FDigSize + zr * 2);
    p[3] := SetPoint((FDigSize + zr) * 2,  FPadding);
    tmRgn := CreatePolygonRgn(p[0], 4, Winding);
    CombineRgn(ArElRgn[5], ArElRgn[5], tmRgn, RGN_DIFF);// 
    DeleteObject(tmRgn);
    p[0] := SetPoint(0, FHeight div 2 - FDigSize div 2 - zr);//h div 2 - FDigSize div 2 + zr);// 
    p[1] := SetPoint(FDigSize div 2, FHeight div 2 - zr);//
    p[2] := SetPoint(FDigSize,  FHeight div 2 - FDigSize div 2 - zr);// 
    p[3] := SetPoint(FDigSize, FHeight);// 
    p[4] := SetPoint(0,  FHeight);// 
    tmRgn := CreatePolygonRgn(p[0], 5, Winding);
    CombineRgn(ArElRgn[5], ArElRgn[5], tmRgn, RGN_DIFF);//     
    DeleteObject(tmRgn);
    //    Size,  ,    ArElRgn[5]
    //      : ArElRgn[1], ArElRgn[2], ArElRgn[4]
    Size := GetRegionData(ArElRgn[5], 0, nil);
    GetMem(RgnData, SizeOf(RGNDATA) * Size);
    GetRegionData(ArElRgn[5], Size, RgnData);
    //    ArElRgn[4]
    FillChar(wXFORM, SizeOf(wXFORM), #0);
    wXFORM.eM11 := 1;
    wXFORM.eM22 := -1;
    ArElRgn[4] := ExtCreateRegion(@wXFORM, Size, RgnData^);
    OffsetRgn(ArElRgn[4], 0, FHeight);
    //    ArElRgn[2]
    FillChar(wXFORM, SizeOf(wXFORM), #0);
    wXFORM.eM11 := -1;
    wXFORM.eM22 := -1;
    ArElRgn[2] := ExtCreateRegion(@wXFORM, Size, RgnData^);
    OffsetRgn(ArElRgn[2], FDigWidth, FHeight);
    //    ArElRgn[1]
    FillChar(wXFORM, SizeOf(wXFORM), #0);
    wXFORM.eM11 := -1;
    wXFORM.eM22 := 1;
    ArElRgn[1] := ExtCreateRegion(@wXFORM, Size, RgnData^);
    OffsetRgn(ArElRgn[1], FDigWidth, 0);
    FreeMem(RgnData);//     ArElRgn[5]
    //   ArElRgn[3]      ArElRgn[0]
    Size := GetRegionData(ArElRgn[0], 0, nil);
    GetMem(RgnData, SizeOf(RGNDATA) * Size);
    GetRegionData(ArElRgn[0], Size, RgnData);
    FillChar(wXFORM, SizeOf(wXFORM), #0);
    wXFORM.eM11 := 1;
    wXFORM.eM22 := -1;
    ArElRgn[3] := ExtCreateRegion(@wXFORM, Size, RgnData^);
    OffsetRgn(ArElRgn[3], 0, FHeight);
    FreeMem(RgnData);//     ArElRgn[0]
    //   ArElRgn[6]
    p[0] := SetPoint(FDigSize div 2 + zr, FHeight div 2);// 
    p[1] := SetPoint(FDigSize + zr, p[0].y - FDigSize div 2);// 
    p[2] := SetPoint(FDigWidth - p[1].x , p[1].y);// 
    p[3] := SetPoint(FDigWidth - p[0].x, p[0].y);// 
    p[4] := SetPoint(p[2].x, p[0].y + FDigSize div 2);// 
    p[5] := SetPoint(p[1].x , p[4].y);//    
    ArElRgn[6] := CreatePolygonRgn(p[0], 6, Winding);
    if FItalic then//  
     begin
      for rd := 0 to 6 do//  
       begin
        Size := GetRegionData(ArElRgn[rd], 0, nil);
        GetMem(RgnData, SizeOf(RGNDATA) * Size);
        GetRegionData(ArElRgn[rd], Size, RgnData);
        FillChar(wXFORM, SizeOf(wXFORM), #0);
        wXFORM.eM11 := 1;
        wXFORM.eM22 := 1;
        wXFORM.eDx := 0.2;
        wXFORM.eM21 := - wXFORM.eDx;
        DeleteObject(ArElRgn[rd]);
        ArElRgn[rd] := ExtCreateRegion(@wXFORM, Size, RgnData^);
        FreeMem(RgnData);
       end;
      GetRgnBox(ArElRgn[4], r);
      for rd := 0 to 6 do OffsetRgn(ArElRgn[rd], -r.Left, 0);  
      tmRgn := CreateRectRgn(0, 0, 0, 0);
      CombineRgn(tmRgn, ArElRgn[1], ArElRgn[4], RGN_OR);//     
      GetRgnBox(tmRgn, r);//      
      DeleteObject(tmRgn);
      FItalicWidth := r.Right - r.Left - FDigWidth;//   
    end
    else FItalicWidth := 0;
   
////////////////////////////////////////////////////////////////////////////////
///////////////////////      /////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////   
   nx := (FDigWidth - FDigSize) div 2;//       ()
   afD := max(0, Round(nx  / 50 *  FDotSize - nx));//    (FSpace)
   bfD := min(Round(FSpace  / 50 *  FDotSize), FSpace) - FSpace + afD;//    
   nx := FPAdding * 2;//        
   if FTextBits then//     
    begin
     str := FText;
     if pos(FDelimiter[1], str) = 0 then//    
      if str2int(str) > 127//    
      then inc(nx, FDigWidth + FSpace + bfD + FDigSize + afD + FSpace)//   
      else inc(nx, FDigWidth + FSpace + (afD + FDigSize + bfD + FSpace) * ord(FAddDot))//     AddDot = True
     else//  
      while str <> '' do
       if str2int(fparse(str, FDelimiter[1])) > 127//   
        then inc(nx, FDigWidth + FSpace + afD + FDigSize + bfD + FSpace)//     
        else  inc(nx, FDigWidth + FSpace + (afD + FDigSize + bfD + FSpace) * ord(FAddDot));//       AddDot = True
    end                                                                   
   else//   
    for i := 0 to Length(FText) - 1 do
     case FText[i + 1] of
      '.': inc(nx, afD + FDigSize + bfD + FSpace);
      '!': inc(nx, FDigWidth + FSpace + afD + FDigSize + bfD + FSpace);//     
      ':': if FSegmentColon//    
            then inc(nx, FDigWidth + FSpace)
            else inc(nx, afD + FDigSize + bfD + FSpace);
      else inc(nx, FDigWidth + FSpace);
     end;

   FTextWidth := max(FDigWidth + FItalicWidth + FPAdding * 2, nx - FSpace + FItalicWidth);//   (       )
   if FAutoWidth and (FTextWidth <>  FWidth) then
    begin
     i := 0;
     while lowercase(PRec^[i].name) <> 'width' do inc(i);
     integer(PRec^[i].Value^) := FTextWidth;//   Width
     FWidth := FTextWidth;
     FDrawBuffer.Width := FTextWidth;
     FDrawBuffer.Canvas.Rectangle(0, 0, FWidth, FHeight);
    end;

   case STextAlign of
  {taLeft}0: nx := FPadding;
 {taRight}1: nx := FWidth - FTextWidth + FPadding;
{taCenter}2: nx := (FWidth - FTextWidth) div 2 + FPadding;
   end;
    
   if FTextBits and (FDelimiter <> '') and (FText <> '') then
    begin
     str := FText;
     if pos(FDelimiter[1], str) = 0 then
      begin
       i := str2int(str);
       if FShowLines then//    
        if (i > 127) or FAddDot then DrawSegment(255, fShadow)//   127,     
        else  DrawSegment(127, fShadow);//  
       DrawSegment(i, FForeground)
      end
     else
      while str <> '' do
       begin
        i := str2int(fparse(str, FDelimiter[1]));
        if FShowLines then//    
         if (i > 127) or FAddDot then DrawSegment(255, fShadow)//   127,     
         else  DrawSegment(127, fShadow);//  
        DrawSegment(i, FForeground);
       end;
    end
   else
    for i := 0 to Length(FText) - 1 do
     begin
      if FShowLines then
       case FText[i + 1] of
        '.': ;
        ':': if FSegmentColon then DrawSegment(127, fShadow);
        else DrawSegment(127, fShadow);
      end;
      case FText[i + 1] of
        ' ': inc(nx, FDigWidth + FSpace);
        '0','O','o': DrawSegment(63, FForeground);
        '1': DrawSegment(6, FForeground);
        '2': DrawSegment(91, FForeground);
        '3': DrawSegment(79, FForeground);
        '4': DrawSegment(102, FForeground);
        '5','S','s': DrawSegment(109, FForeground);
        '6': DrawSegment(125, FForeground);
        '7': DrawSegment(7, FForeground);
        '8': DrawSegment(127, FForeground);
        '9': DrawSegment(111, FForeground);
        'A','a': DrawSegment(119, FForeground);
        'B','b': DrawSegment(124, FForeground);
        'C','c','[','(': DrawSegment(57, FForeground); 
        'D','d': DrawSegment(94, FForeground);
        'E','e': DrawSegment(121, FForeground);
        'F','f': DrawSegment(113, FForeground);
        'G','g': DrawSegment(61, FForeground);
        'H','h': DrawSegment(116, FForeground);
        'I','i': DrawSegment(48, FForeground);
        'J','j': DrawSegment(31, FForeground);
        'K','k': DrawSegment(117, FForeground);
        'L','l': DrawSegment(56, FForeground);
        'M','m': DrawSegment(21, FForeground);
        'N','n': DrawSegment(55, FForeground);
        'P','p': DrawSegment(115, FForeground);
        'Q','q': DrawSegment(103, FForeground);
        'R','r': DrawSegment(51, FForeground);
        'T','t': DrawSegment(120, FForeground);
        'U','u': DrawSegment(62, FForeground);
        'V','v': DrawSegment(46, FForeground);
        'W','w': DrawSegment(42, FForeground);
        'X','x': DrawSegment(118, FForeground);
        'Y','y': DrawSegment(110, FForeground);
        'Z','z': DrawSegment(73, FForeground);
        '\': DrawSegment(96, FForeground);
        ']',')': DrawSegment(15, FForeground);
        '^': DrawSegment(35, FForeground);
        '_': DrawSegment(8, FForeground);
        '!': DrawSegment(130, FForeground);
        '"': DrawSegment(34, FForeground);
        '#': DrawSegment(54, FForeground);
        '$': DrawSegment(105, FForeground);
        '%': DrawSegment(45, FForeground);
        '&': DrawSegment(123, FForeground);
        Char(#39): DrawSegment(32, FForeground);
        '*': DrawSegment(99, FForeground);      
        '+': DrawSegment(112, FForeground);
        ',': DrawSegment(12, FForeground);
        '-': DrawSegment(64, FForeground);       
        '/': DrawSegment(66, FForeground);
        ':': if FSegmentColon
              then DrawSegment(72, FForeground)// 
              else DrawSymbol(':', FForeground);// 
        ';': DrawSegment(76, FForeground);
        '<': DrawSegment(97, FForeground);
        '=': DrawSegment(65, FForeground);
        '>': DrawSegment(67, FForeground);
        '?': DrawSegment(83, FForeground);
        '@': DrawSegment(95, FForeground);
        '.': DrawSymbol('.', FForeground);
       end;
    end;
    
   BitBlt(DC, 0, 0, FWidth, FHeight, FDrawBuffer.Canvas.Handle, 0, 0, SRCCOPY);
   for i := 0 to 6 do DeleteObject(ArElRgn[i]);
   FDrawBuffer.Free;
end;

exports
    Draw;

begin
end.
 